Bug 123516 - Insert a large table with a table style applied rather slow
Summary: Insert a large table with a table style applied rather slow
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
6.0.6.2 release
Hardware: All Windows (All)
: medium normal
Assignee: Jim Raykowski
URL:
Whiteboard: target:6.3.0
Keywords:
Depends on:
Blocks: Writer-Tables
  Show dependency treegraph
 
Reported: 2019-02-17 10:48 UTC by Telesto
Modified: 2019-03-01 05:30 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Telesto 2019-02-17 10:48:53 UTC
Description:
Insert a large table with a table style applied rather slow

Steps to Reproduce:
1. Open Writer
2. Table -> insert
3. 20 columns 800 rows
4. Pick a style like Box list blue (Default style & none aren't affected)

Actual Results:
Delay of 4 seconds or so

Expected Results:
Show appear within a second


Reproducible: Always


User Profile Reset: No



Additional Info:
Found in
Version: 6.3.0.0.alpha0+
Build ID: e0745a11597e5d57eb8001a295314e86810a6027
CPU threads: 4; OS: Windows 6.3; UI render: default; VCL: win; 
TinderBox: Win-x86@42, Branch:master, Time: 2019-02-12_04:16:22
Locale: nl-NL (nl_NL); UI-Language: en-US
Calc: CL

but not in
4.4.7.2
Comment 1 Dieter Praas 2019-02-17 11:54:22 UTC
Can't confirm with

Version: 6.1.5.2 (x64)
Build-ID: 90f8dcf33c87b3705e78202e3df5142b201bd805
CPU-Threads: 4; BS: Windows 10.0; UI-Render: Standard; 
Gebietsschema: de-DE (de_DE); Calc: group threaded

and also not with

Version: 6.3.0.0.alpha0+ (x64)
Build ID: f42554a1886ebe49170c25096dc3281b2c7bb1f4
CPU threads: 4; OS: Windows 10.0; UI render: default; VCL: win; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2019-02-08_22:37:30
Locale: en-US (de_DE); UI-Language: en-US
Calc: threaded
Comment 2 Telesto 2019-02-17 14:25:41 UTC
Found in
Version: 6.0.6.0.0+
Build ID: c30963b8b4bbbe42a24b97aafa161eff9d7ccdd4
CPU threads: 4; OS: Windows 6.3; UI render: default; 
Locale: nl-NL (nl_NL); Calc: CL

but not in
5.4
Comment 3 Telesto 2019-02-17 15:35:54 UTC
Bisected to
author	Jim Raykowski <raykowj@gmail.com>	2018-02-06 22:50:02 -0900
committer	Katarina Behrens <Katarina.Behrens@cib.de>	2018-02-13 22:59:48 +0100
commit	55b37cc3ade30257858515b1a062ff9130488a5f (patch)
tree	6b6f9e4e9d96a4dcf14c7c1eb9535dedc74c81d6
parent	10a5ea8f6365236fcc1d31b940113b3363f56209 (diff)
tdf#108227 Set table style so it is highlighted in Sidebar styles list

https://cgit.freedesktop.org/libreoffice/core/commit/?id=55b37cc3ade30257858515b1a062ff9130488a5f
Comment 4 Dieter Praas 2019-02-17 20:24:56 UTC
cc: Jim Rykowski
Comment 5 Jim Raykowski 2019-02-26 10:30:13 UTC
Hi Telesto and Dieter,

Here is a patch for testing. Let me know if it improves speed of inserting large tables with an auto format table style for you. For a 20 column 800 row table with various auto format table styles my testing shows between 4 and 5 seconds with the patch applied vs between 23 and 27 seconds without. I think that says something about my computer ;-) Maybe it will be less than one second for yours.

https://gerrit.libreoffice.org/#/c/68372/
Comment 6 Telesto 2019-02-26 11:32:22 UTC
(In reply to Jim Raykowski from comment #5)
> Hi Telesto and Dieter,
> 
> Here is a patch for testing. Let me know if it improves speed of inserting
> large tables with an auto format table style for you. For a 20 column 800
> row table with various auto format table styles my testing shows between 4
> and 5 seconds with the patch applied vs between 23 and 27 seconds without. I
> think that says something about my computer ;-) Maybe it will be less than
> one second for yours.
> 
> https://gerrit.libreoffice.org/#/c/68372/

@Buovjaga
-> in the mood to test this.. assuming it exists on Linux too.. I'm lacking a build environment

@Jim
Reset assured ;-).. Looking at the CPU graph on my system (20 seconds) .. 23 seconds isn't that bad.. And the single core performance isn't increasing much as far I know.. 

Anyway thanks for the effort!
Comment 7 Buovjaga 2019-02-26 11:57:11 UTC
(In reply to Jim Raykowski from comment #5)
> Hi Telesto and Dieter,
> 
> Here is a patch for testing. Let me know if it improves speed of inserting
> large tables with an auto format table style for you. For a 20 column 800
> row table with various auto format table styles my testing shows between 4
> and 5 seconds with the patch applied vs between 23 and 27 seconds without. I
> think that says something about my computer ;-) Maybe it will be less than
> one second for yours.
> 
> https://gerrit.libreoffice.org/#/c/68372/

I confirm the delay is gone with this patch.
Comment 8 Commit Notification 2019-03-01 02:45:38 UTC
Jim Raykowski committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/1dc25980171ff79345484631882d6ea0eb6f9388%5E%21

tdf#123516 Speed up insert of large tables with auto format table style

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.